(* Sample DSL expressions *)

open Imgdsl

module Ex1(S:IMGDSL) = struct 
  open S
  let res = int 1 +% int 2 *% int 3
end

module Ex2(S:IMGDSL) = struct 
  open S
  let res = if_ (int 1 >% int 3) (int 4) (int 5)
end

module Ex3(S:IMGDSL) = struct 
  open S
  let res = display (load "takaosan.pgm")
end

module Ex4(S:IMGDSL) = struct 
  open S
  let res = 
    display (iterate (load "takaosan.pgm")
             (if_ (it >% int 120) it (int 0)))
end

module Ex5(S:IMGDSL) = struct 
  open S
  let res =
    (display (iterate (load "takaosan.pgm")
                (if_ (it >% int 128) (int 2 *% (it -% int 128)) (int 0))))
end

